import java.io.*;

public class ICFP2001 {
	public static void main( String[] args ) {
		test1();
//		run();
	}
	
	private static void run() {
		SMLParser parser = new SMLParser();
		Statement doc = parser.parseGrammar(System.in);
		if( doc != null ) {
			SMLMeaning meaning = new SMLMeaning();
			meaning.buildMeaning(doc);
			doc.processRecommendations();
			doc.writeString(System.out);
		}
	}
	
	private static void test1() {
		String[] strs = {
//			"<r>  xxx </r><b> yyy  </b>",
//			"<r> xxx  <b>  yyy </b></r>",
//			"<EM> xxx <EM> yyy </EM> zzz </EM>",
//			"<EM> xxx</EM> yyy <EM>  zzz </EM>",
//			"<B> xxx <B> yyy </B></B>",
//			"<B> xxx  yyy </B>",
//			"<r> xxx </r><b> </b><r> yyy </r>",
//			"<r> xxx yyy </r>",
//			"<EM> xxx <S> yyy </S></EM>",
//			"<EM> xxx </EM><S> yyy </S>",
//			"<I> xxx </I> yyy <I> zzz </I>",
//			"<I> xxx <PL> yyy </PL> zzz </I>",
			"<B><I>bla bla</I></B><TT><I><B>foo bar</B></I> truc</TT>",
			"<B><I>bla bla<TT>foo bar</TT></I></B><TT> truc</TT>",
			"<U> xxx <U> yyy </U></U>",
			"<U> xxx  yyy </U>",
			"<TT><r>  xxx </r><b> yyy  </b></TT>",
			"<TT><r> xxx  <b>  yyy </b></r></TT>",
			"<B> xxx <I> yyy </I> zzz </B>",
			"<B> xxx </B><I> yyy </I><B> zzz </B>",
			"<U><r> xxx </r><b> </b><r> yyy </r></U>",
			"<U><r> xxx   yyy </r></U>",
			"<B><I><B>foo</B></I></B>",
			"<I><B>foo</B></I>",
			"<I><S><TT>foo</TT></S></I> bar <TT><S><I> gee</I></S></TT>",
			"<I><S><TT>foo<PL> bar </PL> gee</TT></S></I>",
			"<B><I><r>bla bla </r> </I> </B> <r><I> barfoo</I></r>",
			"<S> foo <EM> bar </EM> </S> <EM> <EM> foo </EM> </EM>",
			"<S> foo bar</S> foo",
			"<r>aaa</r><g>bbb</g><b>ccc</b><g>ddd</g><r>eee</r>",
			"<r>aaa<g>bbb<b>ccc</b>ddd</g>eee</r>",
			""
		};

  								
		for( int i=0; i<strs.length; i++ ) {
			ByteArrayInputStream in = new ByteArrayInputStream(strs[i].getBytes());
			
			SMLParser parser = new SMLParser();
			Statement doc = parser.parseGrammar(in);
			if( doc != null ) {
				System.out.println(""+i+":");
				System.out.println(strs[i]);
				
				SMLMeaning meaning = new SMLMeaning();
				meaning.buildMeaning(doc);
//				doc.processRecommendations();
				doc.writeString(System.out);
				System.out.println();
			}
			System.out.println();
		}
	}
}