import java.util.*;
import java.io.*;

public class MultiStatement extends Statement {
	ArrayList m_statements = new ArrayList();
	
	public MultiStatement( Statement stmt ) {
		m_statements.add(stmt);
		stmt.setParent(this);
	}
	
	public MultiStatement( ArrayList statements ) {
		m_statements.addAll(statements);
		Iterator iter = m_statements.iterator();
		while( iter.hasNext() ) {
			Statement stmt = (Statement)iter.next();
			stmt.setParent(this);
		}
	}
	
	public void matchTags() {
		
	}
	
	public void removeChild( Statement stmt ) {
		m_statements.remove(stmt);
		if( m_statements.size() == 1 && getParent() != null ) {
			getParent().addChild( (Statement)m_statements.remove(0) );
			getParent().removeChild(this);
		}
	}
	
	public void addChild( Statement stmt ) {
		m_statements.add(stmt);
		stmt.setParent(this);		
	}
	
	public void writeString( PrintStream out ) {
		Iterator iter = m_statements.iterator();
		while( iter.hasNext() ) {
			((Statement)iter.next()).writeString(out);
		}
		
	}
	
	public void setChildContexts( PropertyRecord context ) {
		for( int i=m_statements.size()-1; i >= 0; i-- ) {
			Statement statement = (Statement)m_statements.get(i);
			statement.setContext(context.createCopy());
		}
	}
	
	public void pushChildren( java.util.Stack stack ) {
		for( int i=m_statements.size()-1; i >= 0; i-- ) {
			Statement statement = (Statement)m_statements.get(i);
			stack.push( statement );
		}
	}

	public boolean modifyRecord( PropertyRecord record ) {return false;}
}