import java.io.*;

public abstract class Tag extends Statement {
	protected String m_label = "";
	protected Statement m_child = null;
	
	public Tag( String label, Statement child ) {
		m_label = label;
		m_child = child;
		if( m_child != null ) {
			m_child.setParent(this);
		}
	}
	
	public void writeString( PrintStream out ) {
		out.print("<"+m_label+">");
		m_child.writeString(out);
		out.print("</"+m_label+">");
	}
	
	public void setChildContexts( PropertyRecord context ) {
		m_child.setContext(context.createCopy());
	}
	
	public void pushChildren( java.util.Stack stack ) {
		stack.push(m_child);
	}	
	
	protected void removeChild( Statement child ) {  
		if( m_child == child ) {
			m_child.setParent(null);
			m_child = null;
		}
	}
	
	protected void addChild( Statement child ) {
		m_child = child;
		m_child.setParent(this);
	}
}