import java.awt.Color;

public abstract class TagFactory {
	public static Tag createTag( String label, Statement child ){
		Tag rc = null;
		if(        label.equals("EM") ) {
			rc = new EmphasisTag(child);
		} else if( label.equals("PL") ) {
			rc = new PlainTag(child);
		} else if( label.equals("TT") ) {
			rc = new TypeTag(child);
		} else if( label.equals("B") ) {
			rc = new BoldTag(child);
		} else if( label.equals("I") ) {
			rc = new ItalicsTag(child);
		} else if( label.equals("S") ) {
			rc = new StrongTag(child);
		} else if( label.equals("U") ) {
			rc = new UnderlineTag(child);
		} else if( label.equals("0") ) {
			rc = new SizeTag(child, 0);
		} else if( label.equals("1") ) {
			rc = new SizeTag(child, 1);
		} else if( label.equals("2") ) {
			rc = new SizeTag(child, 2);
		} else if( label.equals("3") ) {
			rc = new SizeTag(child, 3);
		} else if( label.equals("4") ) {
			rc = new SizeTag(child, 4);
		} else if( label.equals("5") ) {
			rc = new SizeTag(child, 5);
		} else if( label.equals("6") ) {
			rc = new SizeTag(child, 6);
		} else if( label.equals("7") ) {
			rc = new SizeTag(child, 7);
		} else if( label.equals("8") ) {
			rc = new SizeTag(child, 8);
		} else if( label.equals("9") ) {
			rc = new SizeTag(child, 9);
		} else if( label.equals("r") ) {
			rc = new ColorTag("r", child, Color.red);
		} else if( label.equals("g") ) {
			rc = new ColorTag("g", child, Color.green);
		} else if( label.equals("b") ) {
			rc = new ColorTag("b", child, Color.blue);
		} else if( label.equals("c") ) {
			rc = new ColorTag("c", child, Color.cyan);
		} else if( label.equals("m") ) {
			rc = new ColorTag("m", child, Color.magenta);
		} else if( label.equals("y") ) {
			rc = new ColorTag("y", child, Color.yellow);
		} else if( label.equals("k") ) {
			rc = new ColorTag("k", child, Color.black);
		} else if( label.equals("w") ) {
			rc = new ColorTag("w", child, Color.white);
		} else {
			System.err.println("Warning: unknown tag type '"+label+"'");
		}
		return rc;
	}
}
